#ifndef __IWeaver_h__
#define __IWeaver_h__

class Event;
class IThreadListener;
class String;
class ThreadStateGraph;

#include "IServerSocket.h"
#include "Vector.h"

class IWeaver : public IServerSocket::ISocketAccepter
{
public:
    virtual void bSync( IThreadListener *thread,
                        const Vector<Event> &requested,
                        const Vector<Event> &watched,
                        const Vector<Event> &blocked ) = 0;
    virtual void removeThread( IThreadListener *thread ) = 0;
    virtual void addThreadBlockingData( const String &threadName, Vector<Event> blockableEvents ) = 0;
    virtual void addThreadStateGraph( const String &threadName, ThreadStateGraph &threadStateGraph ) = 0;
    virtual ~IWeaver() {}
};

#endif // __IWeaver_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
