#ifndef __IEvent_h__
#define __IEvent_h__

#include "Event.h"
#include "Vector.h"

class IEvent
{
public:
    enum EventType {
        INITIATE_MAINTENANCE = 0,
        TEMPERATURE_HIGH = 1,
        TEMPERATURE_LOW = 2,
        TEMPERATURE_ADJUSTED = 3,
        HUMIDITY_HIGH = 4,
        HUMIDITY_LOW = 5,
        HUMIDITY_ADJUSTED = 6,
        COIN_INSERTED = 7,
        PRODUCT_CHOSEN = 8,
        PRODUCT_PROVIDED = 9,
        NUMBER_OF_EVENTS = 10,
    };

    static Vector<Event> allEvents()
    {
        Vector<Event> result;

        for ( unsigned i = 0; i < NUMBER_OF_EVENTS; ++i )
        {
            result.append( Event( i ) );
        }

        return result;
    }
};

#endif // __IEvent_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
